"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ConcatStream = require("concat-stream");
//import * as ZipStream from "zip-stream";
const Archiver = require("archiver");
const Files_1 = require("./Files");
class Archive {
    // constructor
    constructor() {
        // variables
        this.fileNames = [];
        this.fileLocations = [];
        //this.archiveStream = new ZipStream();
        this.archiveStream = new Archiver("zip");
    }
    static ArchiveFilesToMemory(location, files) {
        return __awaiter(this, void 0, void 0, function* () {
            let archive = new Archive();
            archive.fileNames = files;
            for (let i = 0; i < files.length; i++) {
                archive.fileLocations.push(location);
            }
            return yield archive.GetBuffer();
        });
    }
    static ArchiveFilesToResponse(location, files, response) {
        return __awaiter(this, void 0, void 0, function* () {
            let archive = new Archive();
            archive.fileNames = files;
            for (let i = 0; i < files.length; i++) {
                archive.fileLocations.push(location);
            }
            return yield archive.PipeToResponse(response);
        });
    }
    AddFile(location) { this.fileNames.push(location); }
    ArchiveFile(location, fileName) {
        return __awaiter(this, void 0, void 0, function* () {
            //let contents = await Files.ReadFileToBuffer(location + "/" + fileName);
            return new Promise((resolve, reject) => {
                /*
                this.archiveStream
                .entry(
                    ,
                    { name: fileName },
                    function(err, entry) {
                        if(err != null) { return reject(err); }
                        resolve(entry);
                    }
                );
                */
                this.archiveStream
                    .append(Files_1.Files.ReadStream(location + "/" + fileName), { name: fileName }, function (err, entry) {
                    if (err != null) {
                        return reject(err);
                    }
                    resolve(entry);
                });
            });
        });
    }
    GetBuffer() {
        return __awaiter(this, void 0, void 0, function* () {
            let self = this;
            return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
                let concat = ConcatStream(function (result) {
                    resolve(result);
                });
                self.archiveStream.pipe(concat);
                for (let i = 0; i < self.fileNames.length; i++) {
                    yield self.ArchiveFile(self.fileLocations[i], self.fileNames[i]);
                }
                self.archiveStream.finish();
            }));
        });
    }
    PipeToResponse(response) {
        return __awaiter(this, void 0, void 0, function* () {
            response.writeHead(200, {
                'Content-Type': 'application/zip'
            });
            let self = this;
            return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
                self.archiveStream.pipe(response);
                for (let i = 0; i < self.fileNames.length; i++) {
                    self.archiveStream.append(Files_1.Files.ReadStream(self.fileLocations[i] + "/" + self.fileNames[i]), { name: self.fileNames[i] }, null);
                    //await self.ArchiveFile(self.fileLocations[i], self.fileNames[i]);
                }
                self.archiveStream.on("error", function (err) {
                    throw err;
                });
                self.archiveStream.finalize();
                //response.end()
                resolve();
            }));
        });
    }
}
exports.Archive = Archive;
//# sourceMappingURL=Archive.js.map