"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const Archiver = require("archiver");
//import * as ZipStream from "zip-stream";
const FS = require("fs");
const Streams = require("stream");
const Files_1 = require("./Files");
const UnZip = require("node-zip");
const Utilities = require("./All");
class Archives {
    static ZipDirectoryTo(src, dst) {
        return __awaiter(this, void 0, void 0, function* () {
            return new Promise((resolve, reject) => {
                let output = FS.createWriteStream(dst);
                let archive = Archiver("zip", { store: true });
                output.on("close", function () {
                    resolve();
                });
                archive.on("error", function (err) {
                    reject(err);
                });
                archive.pipe(output);
                archive.directory(src, "");
                archive.finalize();
            });
        });
    }
    static ZipDirectoryToBuffer(src) {
        return __awaiter(this, void 0, void 0, function* () {
            let tmp_file_location = "/tmp/" + Utilities.UUID() + ".zip";
            yield Archives.ZipDirectoryTo(src, tmp_file_location);
            let buffer = yield Utilities.Files.ReadFileToBuffer(tmp_file_location);
            yield Utilities.Files.Delete(tmp_file_location);
            return buffer;
        });
    }
    static UnZipBufferToDirectory(src, dst) {
        return __awaiter(this, void 0, void 0, function* () {
            let unzip = UnZip(src, { base64: false });
            let files = unzip.files;
            let keys = Object.keys(files);
            for (let i = 0; i < keys.length; i++) {
                let key = keys[i];
                let entry = files[key];
                if (entry.dir == false) {
                    yield Files_1.Files.Write(dst + "/" + key, entry._data.getContent());
                }
            }
        });
    }
}
exports.Archives = Archives;
class BufferStream extends Streams.Writable {
    constructor(options) {
        super(options);
        this.data = [];
    }
    _write(chunk, enc, cb) {
        this.data.push(chunk);
        cb();
    }
    GetBuffer() { return Buffer.concat(this.data); }
}
//# sourceMappingURL=Archives.js.map