import * as HTTP from "http";
import * as URL from "url";
import * as QueryString from "querystring";
//import * as Cookie from "cookie";

export class Web {

    public static GetPath(request:HTTP.IncomingMessage):string {
        let path = URL.parse(request.url);
        return path.pathname;
    }

    public static async GetRequestParameter(request:HTTP.IncomingMessage):Promise<any> {

        let result:any = null;

        if(request.method == "POST") {
                
            //let data = await RequestHandler.ParseFormData(request);
            //data.fields = data.fields.data == null ? null : JSON.parse(data.fields.data);
            //data.files = await this.PrepareFiles(request, data.files);
            //result = data;
        } 
        else {

            let url = URL.parse(request.url);
            let query = QueryString.parse(url.query);
            result = query.data != null ? {fields:JSON.parse(query.data)} : {fields:query};
        }
        return result;
    }

    public static CopyCookies(from:HTTP.IncomingMessage, to:HTTP.ServerResponse):void {
        if(from.headers["set-cookie"] != null) {
            to.setHeader("Set-Cookie", from.headers["set-cookie"]);
        }
    }
}